/*
 *	piecese/piecese.cpp - P/ECEΉVFgDLL
 *
 *	{vO쐬ɂẮAuł̗bӂƂ͂v(http://www.runan.net/) 
 *	[vO~OTips]->[C++ SDK Tips]->[VFgV[Y]QlɂĒ܂B
 *	҂̃iɁAӂ܂B
 *
 *	* Thu Jan 31 19:10:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "stdafx.h"
#include "piecese.h"

/****************************************************************************
 *	O[oϐ
 ****************************************************************************/

#define PROGID_PieceSE		"PieceSE"
#define CLSID_PieceSE_STRING	"{B5F50E0A-9C39-48bc-90C5-F218D6F979E8}"
GUID CLSID_PieceSE = { 0xb5f50e0a, 0x9c39, 0x48bc, { 0x90, 0xc5, 0xf2, 0x18, 0xd6, 0xf9, 0x79, 0xe8 } };

HINSTANCE g_inst = NULL;	/* DLL̃CX^X */
UINT g_ref = 0;			/* QƃJEg */

/****************************************************************************
 *	DllMain
 ****************************************************************************/

BOOL APIENTRY
DllMain(HINSTANCE hInstance, DWORD  dwReason, LPVOID /*lpReserved*/)
{
	if(dwReason == DLL_PROCESS_ATTACH) {
		g_inst = hInstance;
	}
	return 1; /*  */
}

/****************************************************************************
 *	DllCanUnloadNow
 ****************************************************************************/

STDAPI
DllCanUnloadNow()
{
	/* QƃJEg0ȂS_OKB */
	return g_ref == 0 ? S_OK : S_FALSE;
}

/****************************************************************************
 *	DllCanClassObject
 ****************************************************************************/

STDAPI
DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppvOut)
{
	CPieceSEClassFactory* pcf;
	*ppvOut = NULL;
	if(rclsid == CLSID_PieceSE) {
		/* NXt@Ng̍쐬B */
		pcf = new CPieceSEClassFactory;
		return pcf->QueryInterface(riid, ppvOut);
	}
	/* sCLASS_E_CLASSNOTAVAILABLEԂB */
	return CLASS_E_CLASSNOTAVAILABLE;
}

/****************************************************************************
 *	DllRegisterServer
 ****************************************************************************/

#define KEY_PEX			".pex"
#define VALUE_PEX		PROGID_PieceSE
#define KEY_PFS			".pfs"
#define VALUE_PFS		PROGID_PieceSE
#define KEY_PROGID_PIECESE	PROGID_PieceSE
#define KEY_DEFAULT_ICON	"DefaultIcon"
#define VALUE_DEFAULT_ICON	"%1"
#define KEY_SHELLEX		"shellex"
#define KEY_ICON_HANDLER	"IconHandler"
#define VALUE_ICON_HANDLER	CLSID_PieceSE_STRING
#define KEY_QUERY_INFO		"{00021500-0000-0000-C000-000000000046}" /*IQueryInfõC^[tFCXIDł*/
#define VALUE_QUERY_INFO	CLSID_PieceSE_STRING
#define KEY_CLSID		"CLSID"
#define KEY_CLSID_PIECESE	CLSID_PieceSE_STRING
#define VALUE_CLSID_PIECESE	PROGID_PieceSE
#define KEY_INPROC_SERVER	"InprocServer32"
#define NAME_THREADING_MODEL	"ThreadingModel"
#define VALUE_THREADING_MODEL	"Apartment"

STDAPI
DllRegisterServer()
{
	int result;
	char path[_MAX_PATH];
/*1*/	HKEY keyPex = NULL;
/*2*/	HKEY keyPfs = NULL;
/*3*/	HKEY keyProgIdPieceSE = NULL;
/*4*/	HKEY keyDefaultIcon = NULL;
/*5*/	HKEY keyShellEx = NULL;
/*6*/	HKEY keyIconHandler = NULL;
/*7*/	HKEY keyQueryInfo = NULL;
/*8*/	HKEY keyClsId = NULL;
/*9*/	HKEY keyClsIdPieceSE = NULL;
/*A*/	HKEY keyInprocServer = NULL;

	result = E_FAIL;

#define KEY(p, k, hk)	if(RegCreateKey((p), (k), &(hk)) != ERROR_SUCCESS) goto ERR;
#define VAL(hk, v)	if(RegSetValue((hk), NULL, REG_SZ, v, strlen(v))) goto ERR;
#define VAL2(hk, n, v)	if(RegSetValueEx((hk), (n), 0, REG_SZ, (LPBYTE)(v), strlen(v))) goto ERR;

	/* [HKEY_CLASSES_ROOT\.pex]
	 * @="PieceSE"
	 */
	KEY(HKEY_CLASSES_ROOT, KEY_PEX, keyPex); 
	VAL(                            keyPex, VALUE_PEX);

	/* [HKEY_CLASSES_ROOT\.pfs]
	 * @="PieceSE"
	 */
	KEY(HKEY_CLASSES_ROOT, KEY_PFS, keyPfs); 
	VAL(                            keyPfs, VALUE_PFS);

	/* [HKEY_CLASSES_ROOT\PieceSE]
	 * [HKEY_CLASSES_ROOT\PieceSE\DefaultIcon]
	 * @="%1"
	 * [HKEY_CLASSES_ROOT\PieceSE\shellex]
	 * [HKEY_CLASSES_ROOT\PieceSE\shellex\IconHandler]
	 * @="{B5F50E0A-9C39-48bc-90C5-F218D6F979E8}"
	 * [HKEY_CLASSES_ROOT\PieceSE\ShellEx\{00021500-0000-0000-C000-000000000046}]
	 * @="{B5F50E0A-9C39-48bc-90C5-F218D6F979E8}"
	 */
	KEY(HKEY_CLASSES_ROOT, KEY_PROGID_PIECESE, keyProgIdPieceSE);
	KEY(                                       keyProgIdPieceSE, KEY_DEFAULT_ICON, keyDefaultIcon);
	VAL(                                                                           keyDefaultIcon, VALUE_DEFAULT_ICON);
	KEY(                                       keyProgIdPieceSE, KEY_SHELLEX, keyShellEx);
	KEY(                                                                      keyShellEx, KEY_ICON_HANDLER, keyIconHandler);
	VAL(                                                                                                    keyIconHandler, VALUE_ICON_HANDLER);
	KEY(                                                                      keyShellEx, KEY_QUERY_INFO, keyQueryInfo);
	VAL(                                                                                                  keyQueryInfo, VALUE_ICON_HANDLER);

	/* [HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{B5F50E0A-9C39-48bc-90C5-F218D6F979E8}]
	 * [HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{B5F50E0A-9C39-48bc-90C5-F218D6F979E8}\InprocServer32]
	 * @="D:\\share\\projects\\piece\\piecese\\Debug\\piecese.dll"
	 * "ThreadingModel"="Apartment"
	 */
	KEY(HKEY_CLASSES_ROOT, KEY_CLSID, keyClsId); 
	KEY(                              keyClsId, KEY_CLSID_PIECESE, keyClsIdPieceSE); 
	VAL(                                                           keyClsIdPieceSE, VALUE_CLSID_PIECESE);
	KEY(                                                           keyClsIdPieceSE, KEY_INPROC_SERVER, keyInprocServer); 
	if(GetModuleFileName(g_inst, path, sizeof path) == 0) goto ERR;
	VAL(                                                                                               keyInprocServer, path);
	VAL2(                                                                                              keyInprocServer, NAME_THREADING_MODEL, VALUE_THREADING_MODEL);

#undef VAL
#undef KEY

	result = S_OK;
ERR:
/*A*/	if(keyInprocServer != NULL) RegCloseKey(keyInprocServer);
/*9*/	if(keyClsIdPieceSE != NULL) RegCloseKey(keyClsIdPieceSE);
/*8*/	if(keyClsId != NULL) RegCloseKey(keyClsId);
/*7*/	if(keyQueryInfo != NULL) RegCloseKey(keyQueryInfo);
/*6*/	if(keyIconHandler != NULL) RegCloseKey(keyIconHandler);
/*5*/	if(keyShellEx != NULL) RegCloseKey(keyShellEx);
/*4*/	if(keyDefaultIcon != NULL) RegCloseKey(keyDefaultIcon);
/*3*/	if(keyProgIdPieceSE != NULL) RegCloseKey(keyProgIdPieceSE);
/*2*/	if(keyPfs != NULL) RegCloseKey(keyPfs);
/*1*/	if(keyPex != NULL) RegCloseKey(keyPex);

	return result;
}

/****************************************************************************
 *	DllUnregisterServer
 ****************************************************************************/

static BOOL
DelKey(HKEY hKey, LPCTSTR szSubKey)
{
	char buf[1024];
	HKEY hSubKey;

	/* TuL[JB */
	if(RegOpenKey(hKey, szSubKey, &hSubKey) != ERROR_SUCCESS) return FALSE;
	/* TuL[ł邱ƂmFB */
	if(RegEnumKey(hSubKey, 0, buf, sizeof buf) == ERROR_SUCCESS) {
		RegCloseKey(hSubKey);
		return FALSE;
	}
	/* TuL[B */
	RegCloseKey(hSubKey);
	/* TuL[폜B */
	return RegDeleteKey(hKey, szSubKey) == ERROR_SUCCESS;
}

STDAPI
DllUnregisterServer()
{
	HKEY key1, key2;

	/* [HKEY_CLASSES_ROOT\.pex]
	 * @="PieceSE"
	 */
	DelKey(HKEY_CLASSES_ROOT, KEY_PEX);	/* .pex̓TuL[Ȃ̂łȂ */

	/* [HKEY_CLASSES_ROOT\.pfs]
	 * @="PieceSE"
	 */
	DelKey(HKEY_CLASSES_ROOT, KEY_PFS);	/* .pfs̓TuL[Ȃ̂łȂ */

	/* [HKEY_CLASSES_ROOT\PieceSE]
	 * [HKEY_CLASSES_ROOT\PieceSE\DefaultIcon]
	 * @="%1"
	 * [HKEY_CLASSES_ROOT\PieceSE\shellex]
	 * [HKEY_CLASSES_ROOT\PieceSE\shellex\IconHandler]
	 * @="{B5F50E0A-9C39-48bc-90C5-F218D6F979E8}"
	 * [HKEY_CLASSES_ROOT\PieceSE\ShellEx\{00021500-0000-0000-C000-000000000046}]
	 * @="{B5F50E0A-9C39-48bc-90C5-F218D6F979E8}"
	 */
	if(RegOpenKey(HKEY_CLASSES_ROOT, KEY_PROGID_PIECESE, &key1) == ERROR_SUCCESS) {	/* PieceSEJāA */
		DelKey(key1, KEY_DEFAULT_ICON);						/* DefaultIcon */
		if(RegOpenKey(key1, KEY_SHELLEX, &key2) == ERROR_SUCCESS) {		/* ShellExJāA */
			DelKey(key2, KEY_ICON_HANDLER);					/* IconHandler */
			DelKey(key2, KEY_QUERY_INFO);					/* QueryInfo */
			RegCloseKey(key2);						/* ShellEx */
		}
		DelKey(key1, KEY_SHELLEX);						/* ShellEx */
		RegCloseKey(key1);							/* PieceSE */
	}
	DelKey(HKEY_CLASSES_ROOT, KEY_PROGID_PIECESE);					/* PieceSE */

	/* [HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{B5F50E0A-9C39-48bc-90C5-F218D6F979E8}]
	 * [HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{B5F50E0A-9C39-48bc-90C5-F218D6F979E8}\InprocServer32]
	 * @="D:\\share\\projects\\piece\\piecese\\Debug\\piecese.dll"
	 * "ThreadingModel"="Apartment"
	 */
	if(RegOpenKey(HKEY_CLASSES_ROOT, KEY_CLSID, &key1) == ERROR_SUCCESS) {		/* CLSIDJ */
		if(RegOpenKey(key1, KEY_CLSID_PIECESE, &key2) == ERROR_SUCCESS) {	/* {GUID}J */
			DelKey(key2, KEY_INPROC_SERVER);				/* InprocServer32 */
			RegCloseKey(key2);						/* {GUID} */
		}
		DelKey(key1, KEY_CLSID_PIECESE);					/* {GUID} */
		RegCloseKey(key1);							/* CLSID(CLSID͍Ȃ!!) */
	}

	return S_OK;
}

/****************************************************************************
 *	CPieceSEClassFactory
 ****************************************************************************/

CPieceSEClassFactory::CPieceSEClassFactory()
{
	g_ref++;
	m_ref = 0;
}

CPieceSEClassFactory::~CPieceSEClassFactory()
{
	g_ref--;
}

STDMETHODIMP
CPieceSEClassFactory::QueryInterface(REFIID riid, LPVOID* ppvObj)
{
	*ppvObj = NULL;
	if(riid == IID_IUnknown || riid == IID_IClassFactory) {
		*ppvObj = (IClassFactory*)this;
	}
	if(*ppvObj != NULL) {
		AddRef(); /* YȂ! */
		return S_OK;
	}
	return E_NOINTERFACE;
}

STDMETHODIMP_(ULONG)
CPieceSEClassFactory::AddRef()
{
	return ++m_ref;
}

STDMETHODIMP_(ULONG)
CPieceSEClassFactory::Release()
{
	if(--m_ref == 0) {
		delete this;
		return 0;
	}
	return m_ref;
}

STDMETHODIMP
CPieceSEClassFactory::CreateInstance(LPUNKNOWN pUnkOuter, REFIID riid, LPVOID* ppvObj)
{
	CPieceSE* pse;

	*ppvObj = NULL;

	/* WT|[gĂȂ̂ŋpB */
	if(pUnkOuter != NULL) return CLASS_E_NOAGGREGATION;

	/* VFgIuWFNg쐬B */
	pse = new CPieceSE;
	if(pse == NULL) return E_OUTOFMEMORY;

	/* ړĨC^[tFCX̃|C^擾B */
	return pse->QueryInterface(riid, ppvObj);
}

STDMETHODIMP
CPieceSEClassFactory::LockServer(BOOL /*fLock*/)
{
	/* A邾B */
	return S_OK;
}

/****************************************************************************
 *	CPieceSE
 ****************************************************************************/

CPieceSE::CPieceSE()
{
	memset(m_filename, 0, sizeof m_filename); /* Ô */
	g_ref++;
	m_ref = 0;
}

CPieceSE::~CPieceSE()
{
	g_ref--;
}

STDMETHODIMP
CPieceSE::QueryInterface(REFIID riid, LPVOID* ppvObj)
{
	*ppvObj = NULL;
	if(riid == IID_IUnknown || riid == IID_IPersist) {
		*ppvObj = (IPersist*)this;
	} else if(riid == IID_IPersistFile) {
		*ppvObj = (IPersistFile*)this;
	} else if(riid == IID_IExtractIcon) {
		*ppvObj = (IExtractIcon*)this;
	} else if(riid == IID_IQueryInfo) {
		*ppvObj = (IQueryInfo*)this;
	}
	if(*ppvObj != NULL) {
		AddRef(); /* YȂ! */
		return S_OK;
	}
	return E_NOINTERFACE;
}

STDMETHODIMP_(ULONG)
CPieceSE::AddRef()
{
	return ++m_ref;
}

STDMETHODIMP_(ULONG)
CPieceSE::Release()
{
	if(--m_ref == 0) {
		delete this;
		return 0;
	}
	return m_ref;
}

STDMETHODIMP
CPieceSE::GetClassID(CLSID* /*pClassID*/)
{
	return E_NOTIMPL; /* Ă΂܂ */
}

STDMETHODIMP
CPieceSE::IsDirty()
{
	return E_NOTIMPL; /* Ă΂܂ */
}

STDMETHODIMP
CPieceSE::Load(LPCOLESTR lpszFileName, DWORD /*grfMode*/)
{
	/* ACRot@CANSIɕϊĊi[܂B */
	WideCharToMultiByte(
		CP_ACP,			/* ϊR[hy[W=ANSI */
		0,			/* s̈=none */
		lpszFileName,		/* ϊUnicode */
		-1,			/* ϊ=nulI[ */
		m_filename,		/* ϊobt@ */
		sizeof m_filename,	/* ϊoCg */
		NULL,			/* lpDefaultChar=w */
		NULL);			/* lpUsedDefaultChar=w */
	return S_OK;
}

STDMETHODIMP
CPieceSE::Save(LPCOLESTR /*lpszFileName*/, BOOL /*fRemember*/)
{
	return E_NOTIMPL; /* Ă΂܂ */
}

STDMETHODIMP
CPieceSE::SaveCompleted(LPCOLESTR /*lpszFileName*/)
{
	return E_NOTIMPL; /* Ă΂܂ */
}

STDMETHODIMP
CPieceSE::GetCurFile(LPOLESTR FAR* /*lplpszFileName*/)
{
	return E_NOTIMPL; /* Ă΂܂ */
}

STDMETHODIMP
CPieceSE::GetIconLocation(UINT /*uFlags*/, LPSTR szIconFile, UINT cchMax, int* piIndex, UINT* pwFlags)
{
	strncpy(szIconFile, m_filename, cchMax);		/* t@CԂ(Kv!Extract()łm_filename͎gȂ݂) */
	if(piIndex != NULL) *piIndex = 0;			/* (_~[) */
	if(pwFlags != NULL) *pwFlags = /*GIL_DONTCACHE | */	/* VFɃACRLbVȂ */
				       GIL_NOTFILENAME |	/* szIconFile/piIndex͎g킸AExtract()Ăł炤 */
				       GIL_PERINSTANCE;		/* t@CɕʁX̃ACR\Ă炤 */
	/* ύX: mini ISDɃACRXV@\ǉ̂ŁAGIL_DONTCACHE͊O܂BXʂȂ悤ȋC...(^^; */
	return S_OK;
}

#define ICON_SIZE	32
const unsigned char DEFAULT_IMAGE[ICON_SIZE][ICON_SIZE / 4] = {
	 68, 68, 68, 68, 68, 68, 68, 68, 17, 17, 17, 17, 17, 17, 17, 17,
	 68, 68, 68, 68, 68, 68, 68, 68, 17, 17, 17, 17, 17, 17, 17, 17,
	 68, 68, 68, 68, 68, 68, 68, 68, 17,  0,  0,  0, 17, 17, 17, 17,
	 70, 21, 85, 85,  4, 68, 68, 68, 18, 21, 85, 85, 64,  0,  1,145,
	 70, 21, 85, 85, 85, 85, 86,196, 18, 21, 85, 85, 85, 85, 86,209,
	 70, 21, 85, 85, 85, 85, 86,196, 18, 21, 85, 85, 85, 85, 86,209,
	 70, 21, 85, 85, 85, 85, 86,196, 18, 21, 85, 85, 85, 85, 86,209,
	 70, 21, 85, 85, 85, 85, 86,196, 18, 21, 85, 85, 85, 85, 86,209,
	 70, 21, 85, 85, 85, 85, 86,196, 18, 21, 85, 85, 85, 85, 86,209,
	 70, 21, 85, 85, 85, 85, 86,196, 18, 21, 85, 85, 85, 85, 86,209,
	 70, 21, 85, 85, 85, 85, 86,196, 18, 21, 85, 85, 85, 85, 86,209,
	 70, 21, 85, 85, 85, 85, 86,196, 18, 21, 85, 85, 85, 85, 86,209,
	 70,170,170,170,170,170,170,196, 17, 17, 17, 17, 17, 17, 17, 17,
	 68, 68, 68, 68, 68, 68, 68, 68, 17, 17, 17, 17, 17, 17, 17, 17,
	 68, 68, 68, 68, 68, 68, 68, 68, 17, 17, 17, 17, 17, 17, 17, 17,
	 68, 68, 68, 68, 68, 68, 68, 68, 17, 17, 17, 17, 17, 17, 17, 17,
};
#define ICON_BYTES	(sizeof DEFAULT_IMAGE)

static int extract_pex(LPCSTR path, unsigned char image[ICON_SIZE][ICON_SIZE / 4]);
static int extract_pfs(LPCSTR path, unsigned char image[ICON_SIZE][ICON_SIZE / 4]);

STDMETHODIMP
CPieceSE::Extract(LPCSTR pszFile, UINT /*nIconIndex*/, HICON* phiconLarge, HICON* phiconSmall, UINT /*nIconSize*/)
{
	int retval, n, x, y;
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	unsigned char image[ICON_SIZE][ICON_SIZE / 4];
	unsigned char mask[ICON_SIZE][ICON_SIZE / 8];
	unsigned char color[3];
	ICONINFO icon;
	BITMAPINFOHEADER bi;
	unsigned char *bits, *pixel;
	BITMAP bm;

	if(phiconLarge != NULL) *phiconLarge = NULL;
	if(phiconSmall != NULL) *phiconSmall = NULL;

	icon.fIcon = TRUE;	/* 0:J[\/1:ACR */
	icon.hbmMask = NULL;	/* ܂쐬ĂȂ */
	icon.hbmColor = NULL;	/* ܂쐬ĂȂ */

	/* gqɂāAC[WoĂт܂B
	 * m_filenameł̓_Ȗ͗lB
	 * m_filenameGetIconLocation()ɑ΂wŁAExtract()͕ʂ̃^C~OŌĂ΂̂낤H
	 */
	_splitpath(pszFile, drive, dir, fname, ext);
	if(strcmpi(ext, ".pex") == 0) {
		retval = extract_pex(pszFile, image);
		color[0] = 255; /*B*/
		color[1] = 255; /*G*/
		color[2] = 255; /*R*/
	} else if(strcmpi(ext, ".pfs") == 0) {
		retval = extract_pfs(pszFile, image);
		color[0] = 192; /*B*/
		color[1] = 192; /*G*/
		color[2] = 255; /*R*/
	} else /*肦Ȃ͂*/ {
		goto ERR;
	}

	/* C[WoȂAftHgC[Wg܂B */
	if(!retval) memcpy(image, DEFAULT_IMAGE, sizeof image);

	/* C[Wrbg}bvɓWJ܂B */
	memset(&bi, 0, sizeof bi);
	bi.biSize = sizeof bi;
	bi.biWidth = ICON_SIZE;
	bi.biHeight = -ICON_SIZE; /* gbv_E */
	bi.biPlanes = 1;
	bi.biBitCount = 24;
	icon.hbmColor = CreateDIBSection(NULL, (BITMAPINFO*)&bi, DIB_RGB_COLORS, (void**)&bits, NULL, 0);
	if(icon.hbmColor == NULL) goto ERR;
	retval = GetObject(icon.hbmColor, sizeof bm, &bm);
	if(retval != sizeof bm) goto ERR;
	for(y = 0; y < ICON_SIZE; y++) {
		pixel = bits + bm.bmWidthBytes * y;	/* C擪AhX */
		for(x = 0; x < ICON_SIZE; x++) {
			n = image[y][x / 4];		/* 4sNZPʂ̃oCg */
			n = n >> (3 - (x & 3)) * 2;	/* ̃sNZbit0`1 */
			n = 3 - (n & 3);		/* bit0`1oĖx] */
			*pixel++ = (unsigned char)(color[0] * n / 3); /*B*/
			*pixel++ = (unsigned char)(color[1] * n / 3); /*G*/
			*pixel++ = (unsigned char)(color[2] * n / 3); /*R*/
		}
	}

	/* ͂܂B
	 * }XNCreateDIBSection()ōƁAȂSɂȂ肵܂B
	 * (ȂȂƂ܂Bǂ킩܂B)
	 * dȂ̂ŁACreateBitmap()ł邱Ƃɂ܂B
	 */
	memset(mask, 0, sizeof mask); /* ACR}XN1̂悤ł */
	icon.hbmMask = CreateBitmap(ICON_SIZE, ICON_SIZE, 1, 1, &mask[0][0]);
	if(icon.hbmMask == NULL) goto ERR;

	/* ACR쐬܂B
	 * TCY͖BTCYWindows܂B
	 */
	if(phiconLarge != NULL) *phiconLarge = CreateIconIndirect(&icon);
	if(phiconSmall != NULL) *phiconSmall = CreateIconIndirect(&icon);

	/* FALL THRU */
ERR:
	/* rbg}bv폜܂B
	 * CreateIconIndirect()AArbg}bv͕svłB
	 */
	if(icon.hbmColor != NULL) DeleteObject(icon.hbmColor);
	if(icon.hbmMask != NULL) DeleteObject(icon.hbmMask);

	/* vꂽACR쐬łĂȂ΁AVXeACRg܂B */
	if(phiconLarge != NULL && *phiconLarge == NULL) *phiconLarge = LoadIcon(NULL, IDI_HAND);
	if(phiconSmall != NULL && *phiconSmall == NULL) *phiconSmall = LoadIcon(NULL, IDI_HAND);

	/* Ȃ݂ɃACR̍폜̓VF͂łB
	 * VXeACRJX^ACRAǂċʂĂ̂킩܂񂪁A
	 * ȂƂł͍폜̃^C~O킩Ȃ͂B
	 * AACR̍폜̓VF͂łB
	 * gĂ݂āAGNXv[̃ĂȂ̂ŁA
	 * ԂvƎv܂B
	 */

	return S_OK; /* ɐ܂ */
}

static int
extract_pex(LPCSTR pszFile, unsigned char image[ICON_SIZE][ICON_SIZE / 4])
{
	int result, retval;
	pffsFileHEADER hdr;
	FILE* fp;

	result = 0;
	fp = NULL; /* ܂JĂ܂ */

	/* t@CJ܂B */
	fp = fopen(pszFile, "rb");
	if(fp == NULL) goto ERR;

	/* wb_ǂ݂܂B */
	retval = fread(&hdr, 1, sizeof hdr, fp);
	if(retval != sizeof hdr) goto ERR;

	/* VOl`mF܂B */
	if(hdr.mark != 'X') goto ERR;

	/* ACR܂܂Ă邱ƂmF܂B */
	if(hdr.ofs_icon == 0) goto ERR;

	/* ACRf[^̈ʒuփV[N܂B */
	retval = fseek(fp, hdr.ofs_icon, SEEK_SET);
	if(retval != 0) goto ERR;

	/* ACRf[^ǂݍ݂܂B */
	retval = fread(&image[0][0], 1, ICON_BYTES, fp);
	if(retval != ICON_BYTES) goto ERR;

	result = 1; /*  */
ERR:
	/* t@C܂B */
	if(fp != NULL) fclose(fp);

	return result;
}

static int
extract_pfs(LPCSTR pszFile, unsigned char image[ICON_SIZE][ICON_SIZE / 4])
{
	int result, n;
	FILE* fp;
	char path[_MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];

	result = 0;
	fp = NULL; /* ܂JĂ܂ */

	/* 炩߁Apfst@C̃hCuAfBNg𒊏oĂ܂B */
	_splitpath(pszFile, drive, dir, NULL, NULL);

	/* t@CJ܂B */
	fp = fopen(pszFile, "rb");
	if(fp == NULL) goto ERR;

	/* esǂ... */
	while(fgets(path, sizeof path, fp) != NULL) {
		/* s̋󔒂ƉsR[h菜܂B */
		n = strlen(path);
		while(n > 0 && iswspace(path[n - 1])) {
			n--;
			path[n] = '\0';
		}
		if(n == 0) continue; /* sȂ΂܂B */

		/* pext@CApext@CACR[h܂B */
		_splitpath(path, NULL, NULL, fname, ext); /* t@CƊgqo */
		if(strcmpi(ext, ".pex") == 0) {
			_makepath(path, drive, dir, fname, ext); /* ΃pXőgݗ */
			result = extract_pex(path, image);
			if(result) break; /* Ȃ炱ŌAsȂpB */
		}
	}
	/* pex̃[hɐĔresult=1AłȂ0ɂȂĂ܂B */
ERR:
	/* t@C܂B */
	if(fp != NULL) fclose(fp);

	return result;
}

#define NAME_MAX	32
static int getinfotip_pex(LPCSTR pszFile, char name[NAME_MAX]);
static int getinfotip_pfs(LPCSTR pszFile, char name[NAME_MAX]);

STDMETHODIMP
CPieceSE::GetInfoTip(DWORD /*dwFlags*/, WCHAR** ppwszTip)
{
	int retval;
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	char name[NAME_MAX];
	IMalloc* pm;

	/* gqɂāA^CgoĂт܂B
	 * łExtract()ƈāAm_filenameL݂B
	 * IExtractIconɗႦƁAExtract()ł͂ȂGetIconLocation()Ɠ^C~OŌĂ΂Ă̂낤B
	 */
	_splitpath(m_filename, drive, dir, fname, ext);
	if(strcmpi(ext, ".pex") == 0) {
		retval = getinfotip_pex(m_filename, name);
	} else if(strcmpi(ext, ".pfs") == 0) {
		retval = getinfotip_pfs(m_filename, name);
	} else /*肦Ȃ͂*/ {
		retval = 0;
	}

	/* ^CgoȂAt@Cg܂B */
	if(!retval) strncpy(name, fname, sizeof name);

	/* AP[^擾܂B */
	SHGetMalloc(&pm);

	/* p蓖Ă܂B */
	*ppwszTip = (WCHAR*)pm->Alloc(NAME_MAX * sizeof(WCHAR)); /* ! 2oCgPʂ */
	if(*ppwszTip == NULL) {
		pm->Release(); /* AP[^J */
		return E_OUTOFMEMORY;
	}

	/* }`oCg->UnicodeϊB */
	MultiByteToWideChar(
		CP_ACP,		/* ϊR[hy[W({ꂪ܂܂邩CP_OEM̂悤ȋC邪AANSIœ̂łĂ) */
		0,		/* tOB悭킩ȂBTvɂȂ0ƂĂB */
		name,		/* ϊ */
		-1,		/* ϊ(-1:kI[) */
		*ppwszTip,	/* ϊobt@ */
		NAME_MAX);	/* ϊobt@̕(oCgł͂Ȃ!) */

	/* AP[^J܂B */
	pm->Release();

	return S_OK; /*  */
}

STDMETHODIMP
CPieceSE::GetInfoFlags(DWORD* /*pdwFlags*/)
{
	return E_NOTIMPL; /* Ă΂܂ */
}

static int
getinfotip_pex(LPCSTR pszFile, char name[NAME_MAX])
{
	int result, retval;
	pffsFileHEADER hdr;
	FILE* fp;

	result = 0;
	fp = NULL; /* ܂JĂ܂ */

	/* t@CJ܂B */
	fp = fopen(pszFile, "rb");
	if(fp == NULL) goto ERR;

	/* wb_ǂ݂܂B */
	retval = fread(&hdr, 1, sizeof hdr, fp);
	if(retval != sizeof hdr) goto ERR;

	/* VOl`mF܂B */
	if(hdr.mark != 'X') goto ERR;

	/* ^Cg܂܂Ă邱ƂmF܂B */
	if(hdr.ofs_name == 0) goto ERR;

	/* ^Cgf[^̈ʒuփV[N܂B */
	retval = fseek(fp, hdr.ofs_name, SEEK_SET);
	if(retval != 0) goto ERR;

	/* ^Cgǂݍ݂܂B */
	retval = fread(name, 1, NAME_MAX - 1, fp);
	name[NAME_MAX - 1] = '\0'; /* Ô */

	result = 1; /*  */
ERR:
	/* t@C܂B */
	if(fp != NULL) fclose(fp);

	return result;
}

static int
getinfotip_pfs(LPCSTR pszFile, char name[NAME_MAX])
{
	int result, n;
	FILE* fp;
	char path[_MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];

	result = 0;
	fp = NULL; /* ܂JĂ܂ */

	/* 炩߁Apfst@C̃hCuAfBNg𒊏oĂ܂B */
	_splitpath(pszFile, drive, dir, NULL, NULL);

	/* t@CJ܂B */
	fp = fopen(pszFile, "rb");
	if(fp == NULL) goto ERR;

	/* esǂ... */
	while(fgets(path, sizeof path, fp) != NULL) {
		/* s̋󔒂ƉsR[h菜܂B */
		n = strlen(path);
		while(n > 0 && iswspace(path[n - 1])) {
			n--;
			path[n] = '\0';
		}
		if(n == 0) continue; /* sȂ΂܂B */

		/* pext@CApext@C^Cg[h܂B */
		_splitpath(path, NULL, NULL, fname, ext); /* t@CƊgqo */
		if(strcmpi(ext, ".pex") == 0) {
			_makepath(path, drive, dir, fname, ext); /* ΃pXőgݗ */
			result = getinfotip_pex(path, name);
			if(result) break; /* Ȃ炱ŌAsȂpB */
		}
	}
	/* pex̃[hɐĔresult=1AłȂ0ɂȂĂ܂B */
ERR:
	/* t@C܂B */
	if(fp != NULL) fclose(fp);

	return result;
}
